const {interfaces: Ci,	utils: Cu} = Components;
Cu.import('resource://gre/modules/Services.jsm');
Cu.import('resource://gre/modules/commonjs/toolkit/require.js');

var button;
var wfState = "A";
var curURL = "";

var windowListener = {
	
	
	onOpenWindow: function (aXULWindow) {
		let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
		aDOMWindow.addEventListener("load", function () {
			aDOMWindow.removeEventListener("load", arguments.callee, false);
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}, false);
	},
	
	onStateChange : function(aWebProgress, aRequest, aFlag, aStatus) {},
	
	onCloseWindow: function (aXULWindow) {},
	
	onOnOffClick: function () {},
	
	onWindowTitleChange: function (aXULWindow, aNewTitle) { 
		var aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
		var sidebarBrowser = aDOMWindow.document.getElementById('demo-sidebar-with-html_browser');
		if(wfState === "A")
		{
			var url = getURL();
			curUrl = url;
			if(sidebarBrowser)
			{
				sidebarBrowser.setAttribute('src', getweb(url));
			}
			button.badge = 'A';
			button.badgeColor = "#00AA00";
		}
		else if(wfState === "Q")
		{
			var url = getURL();
			curUrl = url;
			getNumOfComments(url);
		}
	},
	
	register: function () {
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			aDOMWindowG = aDOMWindow;
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}
		Services.wm.addListener(windowListener);
		
		var buttons = require('sdk/ui/button/action');

		button = buttons.ActionButton({
		  id: 'wf-link',
		  label: 'One Web Forum',
		  icon: "./icon64.png",
		  badge: 'A',
		  badgeColor: '#00AA00',
		  onClick: handleClick
		});
	},
	
	unregister: function () {
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			windowListener.unloadFromWindow(aDOMWindow, aXULWindow);
		}
		Services.wm.removeListener(windowListener);
		button.destroy();
	},
	
	loadIntoWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		handleClick();
	},
	
	unloadFromWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		var splitter = aDOMWindow.document.querySelector('#demo-sidebar-with-html_splitter');
	
		if (splitter) {
			var sidebar = aDOMWindow.document.querySelector('#demo-sidebar-with-html_sidebar');
			splitter.parentNode.removeChild(splitter);
			sidebar.parentNode.removeChild(sidebar);
		}
	}
};

function getNumOfComments(url)
{
	var xmlHttp = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);

    //var xmlHttp = new XMLHttpRequest();
    xmlHttp.onreadystatechange = function() { 
        if (xmlHttp.readyState == 4 && xmlHttp.status == 200)
            button.badge = xmlHttp.responseText;
    }
    xmlHttp.open("GET", 'http://webforum.one/getnumcomments.php?url=' + encodeURIComponent(url), true);
    xmlHttp.send(null);
}

function handleClick(state) {
	if(state)
	{
		if(wfState === "A")
		{
			wfState = "Q";
			button.badge = '?';
			button.badgeColor = "#AA0000";
			getNumOfComments(curURL);
		}
		else if(wfState === "Q")
		{
			wfState = "D";
			button.badge = 'D';
			button.badgeColor = "#0000AA";
		}
		else
		{
			wfState = "A";
			button.badge = 'A';
			button.badgeColor = "#00AA00";
		}
	}
	
	let XULWindows = Services.wm.getXULWindowEnumerator(null);
	while (XULWindows.hasMoreElements()) {
		let aXULWindow = XULWindows.getNext();
		let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);

		var browser = aDOMWindow.document.querySelector('#browser');
		if (browser)
		{
			if(wfState === "A") {
				var splitter = aDOMWindow.document.querySelector('#demo-sidebar-with-html_splitter');
				if(splitter)
				{
					
				}
				else
				{
					var splitter = aDOMWindow.document.createElement('splitter');
					var propsToSet = {
						id: 'demo-sidebar-with-html_splitter',
					}
					for (var p in propsToSet) {
						splitter.setAttribute(p, propsToSet[p]);
					}
					
					var sidebar = aDOMWindow.document.createElement('vbox');
					var propsToSet = {
						id: 'demo-sidebar-with-html_sidebar',
					}
					for (var p in propsToSet) {
						sidebar.setAttribute(p, propsToSet[p]);
					}

					var sidebarBrowser = aDOMWindow.document.createElement('browser');
					var url = getURL();
					var propsToSet = {
						id: 'demo-sidebar-with-html_browser',
						type: 'content',
						context: 'contentAreaContextMenu',
						disableglobalhistory: 'true',
						tooltip: 'aHTMLTooltip',
						clickthrough: 'never',
						autoscrollpopup: 'autoscroller',
						flex: '1',
						style: 'min-width: 14em; width: 22em; max-width: 36em;',
						src: getweb(url)
					}
					for (var p in propsToSet) {
						sidebarBrowser.setAttribute(p, propsToSet[p]);
					}
					
					browser.appendChild(splitter);
					sidebar.appendChild(sidebarBrowser);
					browser.appendChild(sidebar);
				}
			}
			else
			{
				var splitter = aDOMWindow.document.querySelector('#demo-sidebar-with-html_splitter');
				if (splitter) {
					var sidebar = aDOMWindow.document.querySelector('#demo-sidebar-with-html_sidebar');
					splitter.parentNode.removeChild(splitter);
					sidebar.parentNode.removeChild(sidebar);
				}
			}
		}
	}
}

function getURL() {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
           getService(Components.interfaces.nsIWindowMediator);
  var recentWindow = wm.getMostRecentWindow("navigator:browser");
  var url = String(recentWindow ? recentWindow.content.document.location : "");
  var index = url.indexOf("?");
  if(index !== -1)
  {
    url = url.substr(0,index);
  }
  return url;
}

function getweb(url)
{
	return 'data:text/html, <!DOCTYPE html><html><head><meta charset=\"UTF-8\"><style>body { margin: 0; } .banner { height: 30px; } iframe { display: block; border: none; height: calc(100vh - 30px); width: 100%; }</style></head><body><iframe src="http://webforum.one/readcomments.php?url=' + encodeURIComponent(url) + '"></iframe></body></html>';
}

function startup(aData, aReason) {
	windowListener.register();
}

function shutdown(aData, aReason) {
	if (aReason == APP_SHUTDOWN) return;
	windowListener.unregister();
}

function install() {}

function uninstall() {}
